Subject: Re: [Simple]Can Message/CPIM be without MIME message-body

From: Graham Klyne <[email-masked]>
Date: Fri, 28 Apr 2006 19:11:32 +0100

Xiang Ting wrote:
> RFC 3862 describes CPIM message format as following:
> [snip1]
>   A complete message looks something like this:
> 
>      m: Content-type: Message/CPIM
>      s:
>      h: (message-metadata-headers)
>      s:
>      e: (encapsulated MIME message-body)
> [/snip1]
> 
> [snip2]
> 2.4.  Message Content
> 
>   The final section of a Message/CPIM is the MIME-encapsulated message
>   content, which follows standard MIME formatting rules [1][2].
> 
>   The MIME content headers MUST include at least a Content-Type header.
>   The content may be any MIME type.
> [/snip2]
> 
> In practice, I encountered a CPIM message without body. My parser
> judged it as an invalid message format, but the opposers said that
> there aren't specifications pointing out that CPIM MUST have a body.
> I want to know whether the standard CPIM must have a encapsulated MIME
> message body?
> 
> Thanks in advance.

This is not something I recall we considered explicitly.  I would say the
conformant way of generating a message would be to include the content-type
header but leave the body empty.

What is less clear to me is whether, in the spirit of "be liberal in what you
accept", it would be good for a receiver to handle the case that no MIME body is
present.  Consider this question:  can there ever be a significant difference
between having an empty message body, and having no message body?  In the former
case, the content-type is specified;  in the latter case, it is not.  What
message body content type would you when replying to a message?  Same as the
received message?  I raise these points so you can see the situation is not
without possible subtleties.

If it came down to me to arbitrate on the basis of the current specification,
I'd say that the MIME body must be present, but may be empty.  (I don't think
there's any statement that the MIME body part is optional.)  However, I was just
one of the editors - the design was a working group consensus activity, and I'd
prefer this matter to be resolved by a similar consensus debate, if possible.

#g

-- 
Graham Klyne
For email:
http://www.ninebynine.org/#Contact

_______________________________________________
Simple mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/simple

---

From: Derek Atkins <[email-masked]>
Date: Fri, 28 Apr 2006 16:24:05 -0400

Hi,

> prefer this matter to be resolved by a similar consensus debate, if possible.

I'm not sure why you'd ever want a CPIM message without a body.

I agree with Graham here.  My personal feeling is that it makes no
sense to have CPIM without a body (but an empty body is okay).  But
if we really need a clarification we're probably going to need to
ask the ADs because the IMPP working group shut down.

-derek
-- 
       Derek Atkins                 617-623-3745
       [email-masked]             www.ihtfp.com
       Computer and Internet Security Consultant